//Silky's games. (SILK0.DAT etc.)
#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <string.h>

void main( int ac, char **av )
{
	FILE				*in;
	FILE				*out;
	char				*tmp[11];
	unsigned char		*buf;
	unsigned char		*filebuf;
	unsigned long		header_length = 0L;
	unsigned int		file_count = 0;

	char				header_filename[12];
	unsigned long		header_filest = 0L;
	unsigned long		header_filelength = 0L;
	unsigned long		data_offset = 0L;
	unsigned long		total_size = 0L;

	unsigned char		ad = 0;
	unsigned char		bd = 0;
	unsigned char		cd = 0x44;
	unsigned char		dd = 0;
	unsigned int		i;

	printf( "mdataX File Divider 060122 (c)Fac.KUROHANE\n" );

	if( ac == 1 )
	{
		printf( "usage: MDATAXD filename\n" );
		return;
	}

	in = fopen( av[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", av[1] );
		return;
	}

	printf( "filename: %s\n", av[1] );

	fread( tmp, 11, 1, in );
	if( memcmp( tmp, "**** With", 9 ) && memcmp( tmp, "With mdataX", 11 ))
	{
		printf( "error: not mdataX format.\n" );
		goto end2;
	}

	//Header size
	buf = ( unsigned char * )calloc( 1, 4 );
	fseek( in, 0x01F4, SEEK_SET );
	fread( buf, 4, 1, in );
	header_length = *( unsigned long *)( buf );
	file_count = ( header_length / 24 ) - 1;
	free( buf );

	printf( "header_length : %08lX(%ld)\n", header_length, header_length );
	printf( "file_count: %d\n", file_count );
	printf( "\n" );

	//Read header
	buf = ( unsigned char * )calloc( 1, header_length );
	fseek( in, 0x01F8, SEEK_SET );
	fread( buf, header_length, 1, in );

	data_offset = ftell( in );

	//Decode
	for( i = 0; i < header_length; i++ )
	{
		ad = buf[i];
		bd = buf[i+1];
		dd = cd;
		cd = ad ^ bd;
		buf[i] = dd;
	}

//	out = fopen( "DECODE_H.BIN", "wb+" );
//	fwrite( buf, (unsigned int)header_length, 1, out );
//	fclose( out );

	for( i = 0; i != file_count; i++ )
	{
		strcpy( header_filename, &buf[i*24] );
		header_filest = *( unsigned long *)( buf + (( i * 24 ) + 16 ));
		header_filelength = *( unsigned long *)( buf + (( i * 24 ) + 20 ));
		total_size += header_filelength;

		printf( "%-13s %08lX-%04lX (%lu)\n",
			header_filename,
			header_filest,
			header_filelength,
			header_filelength
		);

		out = fopen( header_filename, "wb+" );
		if( out == NULL )
		{
			printf( "error: can't write %s\n", header_filename );
			goto end;
		}

		filebuf = ( unsigned char * )calloc( 1, header_filelength );
		fseek( in, header_filest + data_offset, SEEK_SET );
		fread( filebuf, header_filelength, 1, in );
		fwrite( filebuf, header_filelength, 1, out );
		fclose( out );
		free( filebuf );
	}

	printf( "\n" );
	printf( "total_size:  %lu\n", total_size );
	printf( "complete.\n" );

end:;
	free( buf );
end2:;
	fclose( in );
	return;
}
